package com.example;

import org.flywaydb.core.Flyway;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.util.Assert;

import javax.annotation.PreDestroy;

@SpringBootApplication
public class DemoApplication implements CommandLineRunner {
	
	private SimpleDao simpleDao;
	private Flyway flyway;

	@Autowired
	public DemoApplication(final SimpleDao simpleDao, final Flyway flyway) {
		this.simpleDao = simpleDao;
		this.flyway = flyway;
	}

	@Override
	public void run(String... args) throws Exception {
		Assert.isNull(this.simpleDao.findLike("a"), "should return null");
	}
	
	public static void main(String[] args) {
		SpringApplication.run(DemoApplication.class, args);
	}

	@PreDestroy
	public void dropDatabase() {
		flyway.clean();
	}
}
