package com.example;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

/**
 *
 */
@Component
public class SimpleDao {

    private JdbcTemplate jdbcTemplate;

    private final String query = "SELECT uid,length " +
            "            FROM `index` USE INDEX(ix_ig_term_uid_length)" +
            "            WHERE term LIKE ? COLLATE utf8mb4_unicode_ci" +
            "            GROUP BY uid" +
            "            ORDER BY length,prio DESC";

    @Autowired
    public SimpleDao(final JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    public Long findLike(final String s) {
        return jdbcTemplate.query(query, rs -> {
            if (rs.next()) {
                return rs.getLong(1);
            }
            else return null;
        }, s);
    }
    
}
